P32Buf dic;
P16Buf hash;
P16Buf list;
uint32 _dic_size;
byte _l = 1;

#define HASH_SIZE 0x10000
#define HASH_MASK ((HASH_SIZE >> 1) - 1)

uint32 InitCode(uint32 dic_size, byte l)
{
  _dic_size = dic_size*1024;
  _l = l;
  dic = (P32Buf)malloc(_dic_size*sizeof(uint32));
  list = (P16Buf)calloc(_dic_size, sizeof(uint16));
  hash = (P16Buf)malloc((HASH_SIZE)*sizeof(uint16));
  if (dic == NULL || hash == NULL || list == NULL)
    return 0;    
  return _dic_size*(sizeof(uint32)) + _dic_size*(sizeof(uint16)) + (HASH_SIZE)*sizeof(uint16);
}


#define PutCode(code, len)                      \
{      \
  bits |= code << bl;                            \
  if (bl + len > 15)                             \
  {                                              \
    obuf[ot++] = bits;                         \
    obuf[ot++] = bits >> 8;                         \
    bits = code >> (16 - bl);                    \
    bl   = len + bl - 16;                        \
  }                                              \
  else                                           \
    bl += len;                                   \
}

/*
#define PutCode(code, len)                      \
{      \
  obuf[ot++] = code >> 8;\
  obuf[ot++] = code;\
}
*/
void Code(PBuf* ibuffer, uint32 ins, PBuf* obuffer, uint32* ots)
{
  PBuf ibuf = *ibuffer, obuf = *obuffer;
  memset(hash, 0, (HASH_SIZE)*sizeof(uint16));
  byte b, l;
  uint16 bits = 0, bl = 0;
  byte codelen = 8, cl = 0;
  uint32 thres = 0x100, tr;
  uint32 ot = 0;
  uint16 code = ibuf[0], d, k = 0xFF, cc, kk;
  uint32 key;
  uint16 index;
  for (uint32 i = 1; i < ins; i++) 
  {
    b = ibuf[i];
    key = code | (b << 16);
    index = ((key >> 7) ^ key) & HASH_MASK;
    d = hash[index];
    l = 0;
    while (d && ++l < _l && dic[d] != key) d = list[d];
    
    if (d && dic[d] == key)
    {      
      code = d;
      continue;
    } else
    { 
      if (code < 0x100 && cl && kk + cc + 1 < tr - 1) 
      {
        PutCode((kk + cc + 1), cl);
        PutCode(code, 8);
        cl = 0;
      }  
      else 
      {
        if (cl) PutCode(cc, cl); 
        cc = code; cl = codelen; kk = k; tr = thres;
      }
      if (k < _dic_size - 1) 
      {
        list[++k] = hash[index];
        hash[index] = k;
        dic[k] = key;
      }  
      code = b;
    }
    if (k >= thres) 
    {
      codelen++;
      thres <<= 1;
    }
    if (ot >= ins)
      goto Failed;
  }
  if (cl) PutCode(cc, cl); 
  PutCode(code, codelen);
  if (bl) PutCode(0, 15);
  
  obuf[ot++] = ins >> 24; obuf[ot++] = ins >> 16; obuf[ot++] = ins >> 8; obuf[ot++] = ins;
  obuf[ot++] = 1;
  *ots = ot;
  goto Done;
Failed:
  *ibuffer = obuf;
  *obuffer = ibuf;
  ibuf[ins] = 0;
  *ots = ins + 1;
Done:
  return;
}

void DoneCode()
{
  if (dic != NULL) free(dic);
  if (list != NULL) free(list);
  if (hash != NULL) free(hash);
}
