P32Buf dcode;
P16Buf dlen;
 
uint32 InitDeCode(uint32 dic_size)
{
  _dic_size = dic_size*1024;
  dcode = (P32Buf)malloc(_dic_size*sizeof(uint32));
  dlen = (P16Buf)malloc(_dic_size*sizeof(uint16));
  if (dcode == NULL || dlen == NULL)
    return 0;    
  return 4*_dic_size*sizeof(byte);
}


#define GetCode(len)                      \
{\
  while (bl < 24) { cache |= ibuf[i++] << bl; bl += 8; }\
  c = cache & ((1 << len) - 1);\
  cache >>= len;\
  bl -= len;\
}

/*
#define GetCode(len)                      \
{\
  c = (ibuf[i] << 8) | ibuf[i + 1];\
  i += 2;\
}
*/
void DeCode(PBuf* ibuffer, uint32 ins, PBuf* obuffer, uint32* ots)
{
  PBuf ibuf = *ibuffer, obuf = *obuffer;
  if (ins == 0)
  {
    *ots = 0;
    return;
  }  
  if (ibuf[--ins] == 0)
  {
    *ibuffer = obuf;
    *obuffer = ibuf;
    *ots = ins;
    return;
  }
  uint32 os = ibuf[ins - 1] | ibuf[ins - 2] << 8 | ibuf[ins - 3] << 16 | ibuf[ins - 4] << 24;
  byte bl = 0, b8 = 0, codelen = 8;
  uint32 thres = 0x100, k = 0xFF, i = 0, ot = 0, l, cache = 0;
  uint16 c, len = 1;
  PBuf tbuf;
  GetCode(8);
  obuf[ot++] = c;
  while (ot < os)
  {
    if (k < _dic_size - 1)
    {
      dlen[++k] = len + 1;
      dcode[k] = ot - len;
    } 
           
    if (k >= thres) 
    {
      codelen++;
      thres <<= 1;
    }
    
    if (b8)
      GetCode(8)
    else
      GetCode(codelen);
    if (c > k) { c -= k + 1; b8 = 1; } else b8 = 0;
    if (c > 0xFF) {
      len = dlen[c];
      //memmove(&obuf[ot], &obuf[dcode[c]], len); //doesn't work properly
      l = 0; tbuf = &obuf[dcode[c]];
      while (l++ < len) obuf[ot++] = *(tbuf++);
    } else {
      len = 1;
      obuf[ot++] = c;
    }
  }
  *ots = os;  
}

void DoneDeCode()
{
  if (dcode != NULL) free(dcode);
  if (dlen != NULL) free(dlen);
}
